---
title: "Les listes"
weight: 16
output:
  blogdown::html_page:
    toc: false
    fig_width: 6
    dev: "svg"
---

<script src="/rmarkdown-libs/header-attrs/header-attrs.js"></script>


<ul>
<li>Les listes sont des collections d’objets non nécessairement de même classe.</li>
</ul>
<div id="création" class="section level3">
<h3>Création</h3>
<pre class="r"><code>list(1,&quot;a&quot;)</code></pre>
<pre><code>## [[1]]
## [1] 1
## 
## [[2]]
## [1] &quot;a&quot;</code></pre>
<pre class="r"><code>list(1,&quot;a&quot;,list(1,&quot;a&quot;))</code></pre>
<pre><code>## [[1]]
## [1] 1
## 
## [[2]]
## [1] &quot;a&quot;
## 
## [[3]]
## [[3]][[1]]
## [1] 1
## 
## [[3]][[2]]
## [1] &quot;a&quot;</code></pre>
<pre class="r"><code>list(1,&quot;a&quot;,list(1,&quot;a&quot;),function(x){x^2},T,1:2,matrix(1:4,2,2))</code></pre>
<pre><code>## [[1]]
## [1] 1
## 
## [[2]]
## [1] &quot;a&quot;
## 
## [[3]]
## [[3]][[1]]
## [1] 1
## 
## [[3]][[2]]
## [1] &quot;a&quot;
## 
## 
## [[4]]
## function(x){x^2}
## 
## [[5]]
## [1] TRUE
## 
## [[6]]
## [1] 1 2
## 
## [[7]]
##      [,1] [,2]
## [1,]    1    3
## [2,]    2    4</code></pre>
<pre class="r"><code>c(list(1,&quot;a&quot;),list(2,&quot;b&quot;))</code></pre>
<pre><code>## [[1]]
## [1] 1
## 
## [[2]]
## [1] &quot;a&quot;
## 
## [[3]]
## [1] 2
## 
## [[4]]
## [1] &quot;b&quot;</code></pre>
<pre class="r"><code>lapply(c(list(1,&quot;a&quot;),list(2,&quot;b&quot;)),class)</code></pre>
<pre><code>## [[1]]
## [1] &quot;numeric&quot;
## 
## [[2]]
## [1] &quot;character&quot;
## 
## [[3]]
## [1] &quot;numeric&quot;
## 
## [[4]]
## [1] &quot;character&quot;</code></pre>
</div>
<div id="indexation" class="section level3">
<h3>Indexation</h3>
<ul>
<li>Les listes peuvent être indexées par des vecteurs de booléens, d’entier ou par nommage.</li>
</ul>
<pre class="r"><code>list(1,&quot;a&quot;,T)[1:2]</code></pre>
<pre><code>## [[1]]
## [1] 1
## 
## [[2]]
## [1] &quot;a&quot;</code></pre>
<pre class="r"><code>list(1,&quot;a&quot;,T)[c(T,T,F)]</code></pre>
<pre><code>## [[1]]
## [1] 1
## 
## [[2]]
## [1] &quot;a&quot;</code></pre>
<pre class="r"><code>list(a=1,b=&quot;a&quot;,c=T)[c(&quot;a&quot;,&quot;b&quot;)]</code></pre>
<pre><code>## $a
## [1] 1
## 
## $b
## [1] &quot;a&quot;</code></pre>
<ul>
<li>Toutes les commandes précédentes ont renvoyé des sous listes.
Si on veut accéder à un élément en le sortant de la liste, if faut utiliser le double crochet, ou le dollar:</li>
</ul>
<pre class="r"><code>list(1,&quot;a&quot;,T)[[2]]</code></pre>
<pre><code>## [1] &quot;a&quot;</code></pre>
<pre class="r"><code>list(a=1,b=&quot;a&quot;,c=T)[[&quot;b&quot;]]</code></pre>
<pre><code>## [1] &quot;a&quot;</code></pre>
<pre class="r"><code>list(a=1,b=&quot;a&quot;,c=T)$b</code></pre>
<pre><code>## [1] &quot;a&quot;</code></pre>
<p>Pour rajouter de nouveaux éléments, on peut utiliser la concaténation, ou directement avec le dollar</p>
<pre class="r"><code>L&lt;-list(1,&quot;a&quot;,T)
L$nouveau=45
L</code></pre>
<pre><code>## [[1]]
## [1] 1
## 
## [[2]]
## [1] &quot;a&quot;
## 
## [[3]]
## [1] TRUE
## 
## $nouveau
## [1] 45</code></pre>
</div>
<div id="intérêt." class="section level3">
<h3>Intérêt.</h3>
<p>Créer des fonctions qui retournent plusieurs choses:</p>
<pre class="r"><code>epsilon=rnorm(100)
x=rpois(100,1)
y=1.5+3*x+epsilon
lm1&lt;-lm(y~x)|&gt;summary()

is.list(lm1)</code></pre>
<pre><code>## [1] TRUE</code></pre>
<pre class="r"><code>names(lm1)</code></pre>
<pre><code>##  [1] &quot;call&quot;          &quot;terms&quot;         &quot;residuals&quot;     &quot;coefficients&quot; 
##  [5] &quot;aliased&quot;       &quot;sigma&quot;         &quot;df&quot;            &quot;r.squared&quot;    
##  [9] &quot;adj.r.squared&quot; &quot;fstatistic&quot;    &quot;cov.unscaled&quot;</code></pre>
<pre class="r"><code>lapply(lm1,class)</code></pre>
<pre><code>## $call
## [1] &quot;call&quot;
## 
## $terms
## [1] &quot;terms&quot;   &quot;formula&quot;
## 
## $residuals
## [1] &quot;numeric&quot;
## 
## $coefficients
## [1] &quot;matrix&quot; &quot;array&quot; 
## 
## $aliased
## [1] &quot;logical&quot;
## 
## $sigma
## [1] &quot;numeric&quot;
## 
## $df
## [1] &quot;integer&quot;
## 
## $r.squared
## [1] &quot;numeric&quot;
## 
## $adj.r.squared
## [1] &quot;numeric&quot;
## 
## $fstatistic
## [1] &quot;numeric&quot;
## 
## $cov.unscaled
## [1] &quot;matrix&quot; &quot;array&quot;</code></pre>
<pre class="r"><code>lm1$coefficients</code></pre>
<pre><code>##             Estimate Std. Error  t value     Pr(&gt;|t|)
## (Intercept) 1.348450 0.14202360  9.49455 1.514115e-15
## x           3.089587 0.09731297 31.74898 2.244240e-53</code></pre>
<pre class="r"><code>lm1$sigma</code></pre>
<pre><code>## [1] 1.04352</code></pre>
</div>
